﻿using System.ComponentModel;
using System.Collections.ObjectModel;

namespace VisibilityBinding_SelectiveDataSource
{
    public class Entity : INotifyPropertyChanged
    {
		private bool isSelected = false;
		private bool isExpanded = false;
		private System.Windows.Visibility _visibility = System.Windows.Visibility.Visible;

		public event PropertyChangedEventHandler PropertyChanged;

		protected virtual void NotifyPropertyChanged(string propertyname)
		{
			if (PropertyChanged != null)
			{
				PropertyChanged(this, new PropertyChangedEventArgs(propertyname));
			}
		}

        public Entity(string name)
        {
            this.Name = name;
			this.SubEntities = new ObservableCollection<Entity>();
        }

        public string Name
        {
            get;
            set;
        }

        public ObservableCollection<Entity> SubEntities
        {
            get;
            set;
        }

		public bool IsSelected
		{
			get
			{
				return isSelected;
			}
			set
			{
				if (this.isSelected != value)
				{
					this.isSelected = value;
					NotifyPropertyChanged("IsSelected");
				}
			}
		}

		public bool IsExpanded
		{
			get
			{
				return isExpanded;
			}
			set
			{
				if (this.isExpanded != value)
				{
					this.isExpanded = value;
					NotifyPropertyChanged("IsExpanded");
				}
			}
		}

		public System.Windows.Visibility Visibility
		{
			get
			{
				return _visibility;
			}
			set
			{
				if (this._visibility != value)
				{
					this._visibility = value;
					NotifyPropertyChanged("Visibility");
				}
			}
		}
    }
}